#include "font.h"
#include "fxlib.h"
#define TAILLE_MAX (1<<10)
#define NB_MAX 255
#include "MonochromeLib.h"




int getList(unsigned char* name,int* taille)//on recupere la liste de tous les programmes, ainsi que leur taille
{
FONTCHARACTER PathName[20]={'\\','\\','f','l','s','0','\\','*','.','*',0};
int i,compteur,nombre;
FONTCHARACTER nom[20]={0};
unsigned int handle = 0;
FILE_INFO info;

Bfile_FindFirst(PathName,&handle,nom,&info);

for(i = 0,nombre = 0;nom[i] != 0;i++,compteur++)name[nombre*20+i]=nom[i];
taille[nombre]=info.dsize;
nombre++;

while(!Bfile_FindNext(handle,nom,&info) && nombre<NB_MAX)
	{
	for(i = 0;nom[i] != 0;i++,compteur++)name[nombre*20+i]=nom[i];
	taille[nombre]=info.dsize;
	nombre++;
	}


return nombre;

}


int selectionProgramme(unsigned char* name,int* taille,int nombre)
{
int camera = 0;
int curseur= 0;
int i;
unsigned int key;
while(1)
	{
	if(key == KEY_CTRL_DOWN)curseur++;
	if(key == KEY_CTRL_UP)curseur--;
	if(key == KEY_CTRL_EXE && taille[curseur]<TAILLE_MAX)return curseur;
	
	if(curseur >= nombre){curseur = 0;camera = 0;}
	if(curseur <0){curseur = nombre-1;camera = nombre-8;}
	if(curseur >camera+5 && camera<nombre-7)camera++;
	if(curseur-1<camera && camera)camera--;

	for(i = 1;i<8;i++)
		{
		locate(1,i);
		Print(&name[(i+camera-1)*20]);
		locate(17,i);
		if(taille[i+camera-1]<(1<<10))
			{
			PrintV(taille[i+camera-1]);
			locate(21,i);
			Print("B");
			}
		else if(taille[i+camera-1]<(1<<20))
			{
			PrintV(taille[i+camera-1]>>10);
			locate(21,i);
			Print("K");
			}
		else
			{
			PrintV(taille[i+camera-1]>>20);
			locate(21,i);
			Print("M");
			}
		}
	ML_rectangle(0,curseur*8-camera*8,128,curseur*8-camera*8+7,0,ML_XOR,ML_XOR);
	
	ML_rectangle(0,58,128,64,0,ML_WHITE,ML_WHITE);
	locate(1,8);
	Print("number of files : ");
	PrintV(nombre);
	GetKey(&key);
	ML_clear_vram();
	}
}

void afficherOctet(unsigned char octet,int x,int y)
{
unsigned char str[3]={0};
if(((octet/16)%16)<10)str[0]=((octet/16)%16)+'0';
else str[0]=((octet/16)%16) +'A'-10;
if((octet%16)<10)str[1]=(octet%16) +'0';
else str[1]=(octet%16)+'A'-10;

PrintStr(x,y,str);
}


void afficherHex(unsigned char* texte, int camera, int taille)
{
int i,j;
int ligne;
for(i = camera,ligne = 0;ligne<7;ligne++,i++)
	{
	for(j = 0;j<8;j++)
		{
		if(i*8+j <taille)
			{
			afficherOctet(texte[i*8+j],j*9 +2,ligne*8);
			PrintCharXY(j*4+78,ligne*8,texte[i*8+j]);
			}
		}
	}
}

void modifier(unsigned char* name,int taille)
{

unsigned int key;
unsigned char texte[TAILLE_MAX] = {0};
unsigned int keys[]={KEY_CTRL_XTT,KEY_CHAR_LOG,KEY_CHAR_LN,KEY_CHAR_SIN,KEY_CHAR_COS,KEY_CHAR_TAN,KEY_CHAR_FRAC,
KEY_CTRL_FD,KEY_CHAR_LPAR,KEY_CHAR_RPAR,KEY_CHAR_COMMA,KEY_CHAR_STORE,KEY_CHAR_7,KEY_CHAR_8,KEY_CHAR_9,KEY_CHAR_4,
KEY_CHAR_5,KEY_CHAR_6,KEY_CHAR_MULT,KEY_CHAR_DIV,KEY_CHAR_1,KEY_CHAR_2,KEY_CHAR_3,KEY_CHAR_PLUS,KEY_CHAR_MINUS,KEY_CHAR_0,
KEY_CHAR_DP};
unsigned char lettres[]={"abcdefghijklmnopqrstuvwxyz.ABCDEFGHIJKLMNOPQRSTUVWXYZ "};
unsigned int keysEditor[] = {KEY_CHAR_0,KEY_CHAR_1,KEY_CHAR_2,KEY_CHAR_3,KEY_CHAR_4,KEY_CHAR_5,KEY_CHAR_6,KEY_CHAR_7,KEY_CHAR_8,KEY_CHAR_9,KEY_CTRL_XTT
,KEY_CHAR_LOG,KEY_CHAR_LN,KEY_CHAR_SIN,KEY_CHAR_COS,KEY_CHAR_TAN};

int i;
int ecran = 0;
int curseur = 0;
int camera = 0;
int curseurSauvegarde=0;
int alpha=0;
int ok;
int curseurX,curseurY;
unsigned char newName[20] = {0};
if(taille>TAILLE_MAX)return;
if(!readFile(name,texte))return;

while(1)
	{
	if(key == KEY_CTRL_UP && curseur >=16)curseur -=16;
	if(key == KEY_CTRL_DOWN)curseur +=16;
	if(key == KEY_CTRL_LEFT && curseur>-1)curseur--;
	if(key == KEY_CTRL_RIGHT)curseur ++;
	
	if(key == KEY_CTRL_F5)
		{
		
		for(i = taille;i>curseur/2;i--)texte[i]=texte[i-1];
		texte[curseur/2]=0;
		taille++;
		}
	if(key == KEY_CTRL_DEL && curseur)
		{
		for(i = (curseur-1)/2;i<taille;i++)texte[i]=texte[i+1];
		taille--;
		curseur = (curseur-1)&0xFFFE;
		}
	for(i = 0;i<16;i++)
		{
		if(key == keysEditor[i])
			{
			if(curseur & 1)texte[curseur/2] = (texte[curseur/2] & 0xF0) +i;
			else texte[curseur/2] = (texte[curseur/2] & 0xF) +(i<<4);
			curseur++;
			}
		}
	if(key == KEY_CTRL_F3)
		{
		curseur -= 16*7;
		camera-=7;
		}
	if(key == KEY_CTRL_F4)
		{
		curseur += 16*7;
		camera+=7;
		}
	if(key == KEY_CTRL_F1)
		{
		
		PopUpWin(2);
		locate(3,3);
		if(writeFile(name,texte,taille))
			{
			Print("saved as ");
			locate(3,4);
			Print(name);	
			}	
			else
			{
			Print("error ! Unable to");
			locate(3,4);
			Print("save");	
			}
		GetKey(&key);	
		}
		
	if(key == KEY_CTRL_F2)
		{
		
		while(key != KEY_CTRL_EXE)
			{
			if(key == KEY_CTRL_ALPHA)alpha = !alpha;
			for(i = 0;i<27 && curseurSauvegarde<12;i++)
				if(key == keys[i])
					{
					newName[curseurSauvegarde]=lettres[i+(27*alpha)];
					curseurSauvegarde++;
					if(curseurSauvegarde==8)
						{
						ok = 1;
						for(i = 0;i<curseurSauvegarde;i++)if(newName[i]=='.')ok = 0;
						if(ok)
							{
							newName[curseurSauvegarde]='.';
							curseurSauvegarde++;
							}
						i = 30;
						}
					}
			if(key == KEY_CTRL_DEL && curseurSauvegarde)
				{
				for(i = curseurSauvegarde-1;newName[i];i++)newName[i]=newName[i+1];
				curseurSauvegarde--;
				}
			PopUpWin(5);
			locate(3,2);
			Print("save as");
			locate(3,3);
			Print("old name :");
			locate(3,4);
			Print(name);
			locate(3,5);
			Print("new name :");
			locate(3,6);
			Print(newName);	
			ML_line(12+6*curseurSauvegarde,40,12+6*curseurSauvegarde,48,ML_BLACK);		
			GetKey(&key);		
			}
	
		for(i = 0;i<20;i++)name[i]=newName[i];
		PopUpWin(2);
		locate(3,3);
		if(writeFile(name,texte,taille))
			{
			Print("saved as ");
			locate(3,4);
			Print(name);	
			}	
		else
			{
			Print("error ! Unable to");
			locate(3,4);
			Print("save");	
			}
		GetKey(&key);		
		}
	if(curseur<0)curseur=(curseur+16*16)%16;
	if(curseur >taille*2-1)curseur = taille*2-1;
	
	if(curseur/16<camera)camera--;
	if(curseur/16>camera+6)camera++;
	if(camera>taille/8-6)camera = taille/8-6;
	if(camera<0)camera = 0;
	
	ML_clear_vram();
	afficherHex(texte,camera,taille);
	ML_line(0,57,128,57,ML_BLACK);
	PrintStr(0,59,"save  s-as  up   down ins");

	for(i = 1;i<6;i++)ML_line(128*i/6,57,128*i/6,64,ML_BLACK);
	
	curseurX = 9*(curseur%16 /2)+5*(curseur&1);
	curseurY = (curseur/16-camera)*8;
	ML_line(curseurX,curseurY-1,curseurX,curseurY+6,ML_BLACK);
	
	ML_bmp_or(&texte[camera*8],120,0,8,56);
	GetKey(&key);
	
	}
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
unsigned char name[256*20] = {0};
int taille[256] = {0};
int nombre = getList(name,taille);
int choix = selectionProgramme(name,taille,nombre);
modifier(&name[choix*20],taille[choix]);
}







#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section

